import { Node, VariableDeclaration, ClassDeclaration, Identifier } from 'estree';
export declare function create_scopes(expression: Node): {
    map: WeakMap<object, any>;
    scope: Scope;
    globals: Map<string, Node>;
};
export declare class Scope {
    parent: Scope;
    block: boolean;
    declarations: Map<string, Node>;
    initialised_declarations: Set<string>;
    constructor(parent: Scope, block: boolean);
    add_declaration(node: VariableDeclaration | ClassDeclaration): void;
    find_owner(name: string): Scope;
    has(name: string): boolean;
}
export declare function extract_names(param: Node): string[];
export declare function extract_identifiers(param: Node): Identifier[];
